// ---------------------------------------------------------------
// Copyright 2004, SAS Institute Inc.
// ---------------------------------------------------------------
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace EGAddin.CharacterizeData
{
	/// <summary>
	/// Summary description for CharacterizeDataForm.
	/// </summary>
	public class CharacterizeDataForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label lblLib;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cmbServers;
		private System.Windows.Forms.ComboBox cmbLibs;
		

		#region Properties for this add-in task
		/// <summary>
		/// ISASTaskConsumer, our hook to the host application for services
		/// </summary>
		public SAS.Shared.AddIns.ISASTaskConsumer Consumer
		{
			set
			{
				consumer = value;
			}
		}
		private SAS.Shared.AddIns.ISASTaskConsumer consumer = null;

		public string Library
		{
			set
			{
				library = value;
			}
			get
			{
				return library;
			}
		}
		private string library;

		public bool IncludeCharts
		{
			set 
			{
				bCharts = value;
			}
			get
			{
				return bCharts;
			}
		}
		private bool bCharts = false;

		public bool AllMembers
		{
			set
			{
				bAllData = value;
			}
			get
			{
				return bAllData;
			}
		}
		private bool bAllData = false;

		public string DataSet
		{
			set
			{
				dataset = value;
			}
			get
			{
				return dataset;
			}
		}
		private string dataset = "";

		public int Catobs
		{
			set 
			{
				catobs = value;
			}
			get
			{
				return catobs;
			}
		}
		private int catobs = 30;

		#endregion

		private System.Windows.Forms.CheckBox chkCharts;
		private System.Windows.Forms.CheckBox chkAllData;
		private System.Windows.Forms.DataGrid dgMembers;
		private System.Windows.Forms.TextBox txtData;
		
		private string currServer = "";
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtCatobs;
		private System.Windows.Forms.Label lblData;

		public CharacterizeDataForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CharacterizeDataForm));
			this.lblLib = new System.Windows.Forms.Label();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.cmbServers = new System.Windows.Forms.ComboBox();
			this.cmbLibs = new System.Windows.Forms.ComboBox();
			this.chkCharts = new System.Windows.Forms.CheckBox();
			this.chkAllData = new System.Windows.Forms.CheckBox();
			this.dgMembers = new System.Windows.Forms.DataGrid();
			this.lblData = new System.Windows.Forms.Label();
			this.txtData = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtCatobs = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.dgMembers)).BeginInit();
			this.SuspendLayout();
			// 
			// lblLib
			// 
			this.lblLib.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblLib.Location = new System.Drawing.Point(9, 44);
			this.lblLib.Name = "lblLib";
			this.lblLib.Size = new System.Drawing.Size(166, 23);
			this.lblLib.TabIndex = 2;
			this.lblLib.Text = "Select a library to analyze:";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(225, 358);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 11;
			this.btnOK.Text = "OK";
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(310, 358);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 12;
			this.btnCancel.Text = "Cancel";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(9, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(167, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select a SAS server to use:";
			// 
			// cmbServers
			// 
			this.cmbServers.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbServers.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbServers.Location = new System.Drawing.Point(179, 11);
			this.cmbServers.Name = "cmbServers";
			this.cmbServers.Size = new System.Drawing.Size(201, 21);
			this.cmbServers.TabIndex = 1;
			this.cmbServers.SelectedIndexChanged += new System.EventHandler(this.cmbServers_SelectedIndexChanged);
			// 
			// cmbLibs
			// 
			this.cmbLibs.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbLibs.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbLibs.Location = new System.Drawing.Point(178, 42);
			this.cmbLibs.Name = "cmbLibs";
			this.cmbLibs.Size = new System.Drawing.Size(203, 21);
			this.cmbLibs.TabIndex = 3;
			this.cmbLibs.SelectedIndexChanged += new System.EventHandler(this.cmbLibs_SelectedIndexChanged);
			// 
			// chkCharts
			// 
			this.chkCharts.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.chkCharts.Location = new System.Drawing.Point(17, 293);
			this.chkCharts.Name = "chkCharts";
			this.chkCharts.Size = new System.Drawing.Size(197, 24);
			this.chkCharts.TabIndex = 8;
			this.chkCharts.Text = "Include charts in the report";
			this.chkCharts.CheckedChanged += new System.EventHandler(this.chkCharts_CheckedChanged);
			// 
			// chkAllData
			// 
			this.chkAllData.Location = new System.Drawing.Point(12, 75);
			this.chkAllData.Name = "chkAllData";
			this.chkAllData.Size = new System.Drawing.Size(364, 20);
			this.chkAllData.TabIndex = 4;
			this.chkAllData.Text = "Analyze all data sets in the selected library";
			this.chkAllData.CheckedChanged += new System.EventHandler(this.chkAllData_CheckedChanged);
			// 
			// dgMembers
			// 
			this.dgMembers.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.dgMembers.CaptionFont = new System.Drawing.Font("Verdana", 8F);
			this.dgMembers.CaptionText = "Select the data set to analyze:";
			this.dgMembers.ColumnHeadersVisible = false;
			this.dgMembers.DataMember = "";
			this.dgMembers.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgMembers.Location = new System.Drawing.Point(184, 106);
			this.dgMembers.Name = "dgMembers";
			this.dgMembers.Size = new System.Drawing.Size(204, 183);
			this.dgMembers.TabIndex = 7;
			this.dgMembers.CurrentCellChanged += new System.EventHandler(this.OnCurrentDataCellChanged);
			// 
			// lblData
			// 
			this.lblData.Location = new System.Drawing.Point(16, 108);
			this.lblData.Name = "lblData";
			this.lblData.Size = new System.Drawing.Size(100, 16);
			this.lblData.TabIndex = 5;
			this.lblData.Text = "Selected data:";
			// 
			// txtData
			// 
			this.txtData.Location = new System.Drawing.Point(18, 130);
			this.txtData.Name = "txtData";
			this.txtData.Size = new System.Drawing.Size(154, 20);
			this.txtData.TabIndex = 6;
			this.txtData.Text = "";
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label3.Location = new System.Drawing.Point(18, 324);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(221, 16);
			this.label3.TabIndex = 9;
			this.label3.Text = "Max records to analyze in each data set:";
			// 
			// txtCatobs
			// 
			this.txtCatobs.Location = new System.Drawing.Point(247, 320);
			this.txtCatobs.Name = "txtCatobs";
			this.txtCatobs.Size = new System.Drawing.Size(70, 20);
			this.txtCatobs.TabIndex = 10;
			this.txtCatobs.Text = "30";
			this.txtCatobs.TextChanged += new System.EventHandler(this.txtCatobs_TextChanged);
			// 
			// CharacterizeDataForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(395, 388);
			this.Controls.Add(this.txtCatobs);
			this.Controls.Add(this.txtData);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.lblData);
			this.Controls.Add(this.dgMembers);
			this.Controls.Add(this.chkAllData);
			this.Controls.Add(this.chkCharts);
			this.Controls.Add(this.cmbLibs);
			this.Controls.Add(this.cmbServers);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.lblLib);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(403, 368);
			this.Name = "CharacterizeDataForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Characterize Data";
			this.Load += new System.EventHandler(this.CharacterizeDataForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dgMembers)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void CharacterizeDataForm_Load(object sender, System.EventArgs e)
		{
			if (consumer == null)
				throw new System.Exception("Must set ISASTaskConsumer as Consumer property!");
			
			// get the list of available servers from the application
			string[] servers;
			consumer.Servers(out servers);

			if (servers.Length == 0)
				throw new System.Exception("No servers are available!");

			// populate the servers combobox
			cmbServers.Items.AddRange(servers);			
			if (consumer.AssignedServer.Length>0)
				cmbServers.SelectedItem = consumer.AssignedServer;

			currServer = cmbServers.SelectedItem.ToString();

			PopulateLibraryList();

			chkCharts.Checked = bCharts;
			chkAllData.Checked = bAllData;
			txtCatobs.Text = catobs.ToString();
			txtData.Text = dataset;

			UpdateControls();
			
		}

		

		private void PopulateLibraryList()
		{
			Cursor c = Cursor.Current;
			Cursor.Current = Cursors.WaitCursor;

			cmbLibs.Items.Clear();
			string[] libs;

			consumer.Libraries(cmbServers.SelectedItem.ToString(), out libs);
			if (libs.Length == 0)
			{
				Cursor.Current = c;
				throw new System.Exception("No libraries are available!");
			}

			cmbLibs.Items.AddRange(libs);

			if (cmbLibs.Items.Contains(library))
				cmbLibs.SelectedItem = library;
			else
				cmbLibs.SelectedIndex = 0;

			Cursor.Current = c;

		}

		// uses the Workspace property of the ISASTaskConsumer
		// and the SAS IOM OLEDB Provider to connect to
		// the SAS session and query for additional information
		// about the SAS data
		private void PopulateDatasetList(string libname)
		{
			string server = "";
			SAS.Workspace ws = null;
			try
			{
				server = consumer.AssignedServer;
				ws = consumer.Workspace(server) as SAS.Workspace;		
			}
			catch (Exception ex)
			{
				throw new System.Exception("ISASTaskConsumer.Workspace is not usable!",ex);
			}

			if (server.Length>0 && ws!=null)
			{

				ADODB.Recordset adorecordset = new ADODB.RecordsetClass();
				ADODB.Connection adoconnect = new ADODB.ConnectionClass();

				try
				{
					adoconnect.Open("Provider=sas.iomprovider.1; SAS Workspace ID=" + ws.UniqueIdentifier, "", "", 0);
					// use the SASHELP.VMEMBER view to get names of all of the datasets and views in the specified library
					string selectclause = "select memname, memtype from sashelp.vmember where libname='" + libname + "' and memtype in ('DATA', 'VIEW')";
					adorecordset.Open( selectclause, adoconnect, ADODB.CursorTypeEnum.adOpenForwardOnly, ADODB.LockTypeEnum.adLockReadOnly, (int) ADODB.CommandTypeEnum.adCmdText);
					
					OleDbDataAdapter da = new OleDbDataAdapter();
					DataSet ds = new DataSet();
					da.Fill(ds, adorecordset, "data");
					dgMembers.SetDataBinding(ds, "data");

				}
				catch
				{

				}

				finally
				{
					adoconnect.Close();
				}

			}
		}

		private void UpdateControls()
		{
			dgMembers.Enabled = !bAllData;
			txtData.Enabled = !bAllData;
			lblData.Enabled = !bAllData;
		}

		private void cmbServers_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				PopulateLibraryList();
				currServer = cmbServers.SelectedItem.ToString();
			}
			catch
			{
				MessageBox.Show(string.Format("There was an error trying to connect to \"{0}\".", cmbServers.SelectedItem),"Connection error");
				cmbServers.SelectedItem = currServer;
			}
		}

		private void cmbLibs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			library = cmbLibs.SelectedItem.ToString();
			PopulateDatasetList(library);
		}

		private void chkCharts_CheckedChanged(object sender, System.EventArgs e)
		{
			bCharts = chkCharts.Checked;
		}

		private void chkAllData_CheckedChanged(object sender, System.EventArgs e)
		{
			bAllData = chkAllData.Checked;
			UpdateControls();
		}

		private void OnCurrentDataCellChanged(object sender, System.EventArgs e)
		{
			try
			{
				DataSet ds = dgMembers.DataSource as DataSet;
				txtData.Text = ds.Tables[0].Rows[dgMembers.CurrentCell.RowNumber].ItemArray.GetValue(0).ToString();
				dataset = txtData.Text;
			}
			catch
			{
			}
			
		}

		private void txtCatobs_TextChanged(object sender, System.EventArgs e)
		{
			try
			{
				catobs = Convert.ToInt32(txtCatobs.Text);
			}
			catch
			{
			}

		}
	}
}
