
PROC SORT
	DATA=WORK.FREQ;
	BY Column;
RUN;

Axis1
	STYLE=1
	WIDTH=1
	LABEL=(FONT='Microsoft Sans Serif' HEIGHT=12pt JUSTIFY=Right 'Value');

Axis2
	STYLE=1
	WIDTH=1
	LABEL=(FONT='Microsoft Sans Serif' HEIGHT=12pt JUSTIFY=Center 'Count (n)');

TITLE;

PROC GCHART DATA=WORK.FREQ;
  HBAR3D	 value
  /
	SUMVAR=COUNT
	SHAPE=CYLINDER
	FRAME
	TYPE=CPCT
	NOLEGEND
	DESCENDING
  MAXIS=AXIS1
  RAXIS=AXIS2
  ;
	BY Column;
RUN; QUIT;
TITLE; FOOTNOTE;

PROC SORT DATA=WORK.UNIV;
	BY variable;
RUN;

PROC TRANSPOSE	
  DATA=WORK.UNIV 
  OUT=WORK.TPUNIV(LABEL="Transposed WORK.UNIV")
	PREFIX=Column
	NAME=Source
	LABEL=Label
  ;
	BY variable;
	VAR Min Mean Median Max;
RUN; QUIT;

Axis1
	STYLE=1
	WIDTH=1
	LABEL=(FONT='Microsoft Sans Serif' HEIGHT=12pt JUSTIFY=Right 'Value');

Axis2
	STYLE=1
	WIDTH=1
	LABEL=(FONT='Microsoft Sans Serif' HEIGHT=12pt JUSTIFY=Center 'Statistic');

TITLE;

PROC GCHART DATA=WORK.TPUNIV;
VBAR3D	 Source
 /
	SUMVAR=Column1
	SHAPE=CYLINDER
	FRAME
	NOLEGEND
	ASCENDING
RAXIS=AXIS1
MAXIS=AXIS2
;
	BY variable;
RUN; QUIT;
