// ---------------------------------------------------------------
// Copyright 2004, SAS Institute Inc.
// ---------------------------------------------------------------
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace EGAddin.LifeExpectancy
{
	/// <summary>
	/// Summary description for LifeExpectancyForm.
	/// </summary>
	public class LifeExpectancyForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton btnMale;
		private System.Windows.Forms.RadioButton btnFemale;
		private System.Windows.Forms.TextBox txtAge;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.LinkLabel linkWS;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#region public properties
		public int Age
		{
			set 
			{
				age = value;
			}
			get
			{
				return age;
			}
		}
		private int age = 30;
		private System.Windows.Forms.CheckBox chkReport;

		public LifeExpectancy.LEGender Gender
		{
			set 
			{
				gender = value;
			}
			get
			{
				return gender;
			}
		}
		private LifeExpectancy.LEGender gender = LifeExpectancy.LEGender.Male;

		public bool ShowReport
		{
			set
			{
				bShowReport = value;
			}
			get
			{
				return bShowReport;
			}
		}
		private bool bShowReport = false;
		#endregion

		public LifeExpectancyForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		protected override void OnLoad(EventArgs e)
		{
			// init fields
			txtAge.Text = age.ToString();
			if (gender == LifeExpectancy.LEGender.Male)
				btnMale.Checked = true;
			else btnFemale.Checked = true;

			chkReport.Checked = bShowReport;

			base.OnLoad (e);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LifeExpectancyForm));
			this.label1 = new System.Windows.Forms.Label();
			this.btnMale = new System.Windows.Forms.RadioButton();
			this.btnFemale = new System.Windows.Forms.RadioButton();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.txtAge = new System.Windows.Forms.TextBox();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.linkWS = new System.Windows.Forms.LinkLabel();
			this.chkReport = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(10, 7);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Enter age:";
			// 
			// btnMale
			// 
			this.btnMale.Checked = true;
			this.btnMale.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnMale.Location = new System.Drawing.Point(35, 70);
			this.btnMale.Name = "btnMale";
			this.btnMale.Size = new System.Drawing.Size(104, 15);
			this.btnMale.TabIndex = 3;
			this.btnMale.TabStop = true;
			this.btnMale.Text = "Male";
			this.btnMale.CheckedChanged += new System.EventHandler(this.btnMale_CheckedChanged);
			// 
			// btnFemale
			// 
			this.btnFemale.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnFemale.Location = new System.Drawing.Point(35, 89);
			this.btnFemale.Name = "btnFemale";
			this.btnFemale.Size = new System.Drawing.Size(104, 16);
			this.btnFemale.TabIndex = 4;
			this.btnFemale.Text = "Female";
			this.btnFemale.CheckedChanged += new System.EventHandler(this.btnMale_CheckedChanged);
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Location = new System.Drawing.Point(15, 41);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(222, 74);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Select your gender";
			// 
			// txtAge
			// 
			this.txtAge.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtAge.Location = new System.Drawing.Point(118, 7);
			this.txtAge.MaxLength = 4;
			this.txtAge.Name = "txtAge";
			this.txtAge.TabIndex = 1;
			this.txtAge.Text = "";
			this.txtAge.Validating += new System.ComponentModel.CancelEventHandler(this.OnAgeValidating);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCancel.Location = new System.Drawing.Point(163, 235);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 14;
			this.btnCancel.Text = "Cancel";
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnOK.Location = new System.Drawing.Point(78, 235);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 13;
			this.btnOK.Text = "OK";
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label2.Location = new System.Drawing.Point(12, 172);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(224, 31);
			this.label2.TabIndex = 15;
			this.label2.Text = "This add-in accesses a web service hosted by:";
			// 
			// linkWS
			// 
			this.linkWS.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.linkWS.Location = new System.Drawing.Point(28, 200);
			this.linkWS.Name = "linkWS";
			this.linkWS.Size = new System.Drawing.Size(194, 17);
			this.linkWS.TabIndex = 16;
			this.linkWS.TabStop = true;
			this.linkWS.Text = "www.xignite.com";
			this.linkWS.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// chkReport
			// 
			this.chkReport.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chkReport.Location = new System.Drawing.Point(19, 127);
			this.chkReport.Name = "chkReport";
			this.chkReport.Size = new System.Drawing.Size(216, 24);
			this.chkReport.TabIndex = 17;
			this.chkReport.Text = "Create report output";
			this.chkReport.CheckedChanged += new System.EventHandler(this.chkReport_CheckedChanged);
			// 
			// LifeExpectancyForm
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(250, 269);
			this.Controls.Add(this.chkReport);
			this.Controls.Add(this.linkWS);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.txtAge);
			this.Controls.Add(this.btnFemale);
			this.Controls.Add(this.btnMale);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.groupBox1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(258, 276);
			this.Name = "LifeExpectancyForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "How long have I got?";
			this.ResumeLayout(false);

		}
		#endregion

		private void OnAgeValidating(object sender, System.ComponentModel.CancelEventArgs e)
		{	
			try
			{
				age = Convert.ToInt32(txtAge.Text);
			}
			catch
			{
				MessageBox.Show("Please enter an integer for Age.");
				e.Cancel = true;
			}
		}

		private void btnMale_CheckedChanged(object sender, System.EventArgs e)
		{
			gender = btnMale.Checked ? LifeExpectancy.LEGender.Male : LifeExpectancy.LEGender.Female;	
		}

		private void chkReport_CheckedChanged(object sender, System.EventArgs e)
		{
			bShowReport = chkReport.Checked;
		}
	}
}
