using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace EGAddin.SASProducts
{
	/// <summary>
	/// Summary description for SASListView.
	/// </summary>
	public class SASListView : System.Windows.Forms.ListView
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool _b = true;
		private string _msg = "Select a server and click Show SAS Products";

		public string Message
		{
			set 
			{ 
				_msg = value; 
				this.Invalidate();
			}
		}

		public SASListView()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			this.Resize +=new EventHandler(SASListView_Resize);

			// TODO: Add any initialization after the InitializeComponent call

		}

		#region Overrides to show message in list view
		protected override void WndProc(ref Message m)
		{
			base.WndProc(ref m);
			if (m.Msg == 20)
			{
				if (this.Items.Count == 0)
				{
					this.GridLines = false;
					_b = true;
					Graphics g = this.CreateGraphics();
					int w = 0;
					w = this.Width;
					w -= g.MeasureString(_msg, this.Font).ToSize().Width;
					w = w/2;
					g.DrawString(_msg, this.Font, SystemBrushes.ControlText, w, 30);
				}
				else
				{
					if (_b)
					{
						this.GridLines = true;
						this.Invalidate();
						_b = false;
					}
				}
			}
			if (m.Msg == 4127)
			{
				this.Invalidate();
			}
		}

		private void SASListView_Resize(object sender, EventArgs e)
		{
			if (_b) Invalidate();
		}
		#endregion

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion
	}
}
