
data _prdrep (keep=prodname IsLicensed IsInstalled);
set sasprods;
length IsLicensed $ 3 IsInstalled $ 10;
label IsLicensed="Licensed?" IsInstalled="Installed?" prodname="SAS Product";
if licensed eq 1 then
   IsLicensed = "Yes";
else IsLicensed = "No";

if indexc(installed,"<unknown>")=0 and length(installed)>1 then
  IsInstalled = "Yes";
else if indexc(installed,"<unknown>")>0 then 
  IsInstalled = "Unknown";
else IsInstalled = "No";
run;

title1 "Report of Licensed Products on &_SASSERVERNAME";
title2 "Host name: &_SASHOSTNAME, Host type: &SYSSCPL, SAS version: &SYSVER";
footnote "Generated on %SYSFUNC(DATE(), EURDFDE9.) at %SYSFUNC(TIME(), TIMEAMPM8.)";
proc print label noobs;
var prodname IsLicensed IsInstalled;
run;
title; footnote;